//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyFullScene.h"


void MyFullScene::CreateLODScene(bool in_paged, bool in_moreTextures, bool in_mipmap) 
{
	string dir = "LOD";
	string dir2 = "_lod";
	if (in_paged) {
		dir = "Paged" + dir;
		dir2 = "";
	}

	
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T11.osgt", osg::Vec3(-18.717, -224.813, 1.972)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T12.osgt", osg::Vec3(73.848, -224.812, 5.333)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T13.osgt", osg::Vec3(159.607, -223.781, 8.303)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T14.osgt", osg::Vec3(235.837, -223.781, 6.884)));

	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T21.osgt", osg::Vec3(-18.717, -122.031, 2.125)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T22.osgt", osg::Vec3(73.848, -122.031, 7.719)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T23.osgt", osg::Vec3(159.267, -121.344, 9.566)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T24.osgt", osg::Vec3(235.497, -121.344, 12.13)));
	
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T31.osgt", osg::Vec3(-18.377, -25.094, 9.675)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T32.osgt", osg::Vec3(74.188, -25.094, 22.758)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T33.osgt", osg::Vec3(159.607, -25.438, 19.405)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T34.osgt", osg::Vec3(235.837, -25.438, 12.279)));

	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T41.osgt", osg::Vec3(-18.036, 61.531, 11.251)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T42.osgt", osg::Vec3(74.529, 61.531, 17.722)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T43.osgt", osg::Vec3(159.947, 61.531, 17.206)));
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/terrain/" + dir + "/T44.osgt", osg::Vec3(236.177, 61.531, 9.357)));
	

	//veza
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/tower/tower" + dir2 + ".osgt", osg::Vec3(66.426, -4.814, 36.594)));
	//kostol
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/church/church" + dir2 + ".osgt", osg::Vec3(-31.799, -24.818, -0.094), 114.388));
	//studna1
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/well/well" + dir2 + ".osgt", osg::Vec3(-22.358, -57.734, 0.678)));
	//hut 1
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/hut/hut" + dir2 + ".osgt", osg::Vec3(6.749, -63.738, 0.377), -99.619));
	//house2
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house2/house2" + dir2 + ".osgt", osg::Vec3(-38.742, -71.217, 0.0), 131.637));
	//house3
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house3/house3" + dir2 + ".osgt", osg::Vec3(-35.299, -105.498, -0.024), -87.429));
	//house4
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house4/house4" + dir2 + ".osgt", osg::Vec3(1.012, -101.636, 0.098), -74.142));
	//house5
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house5/house5" + dir2 + ".osgt", osg::Vec3(-28.306, -143.253, -0.058), 115.359));
	//house6
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house6/house6" + dir2 + ".osgt", osg::Vec3(-11.156, -177.195, 0.603), 34.439));
	//studna2
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/well/well" + dir2 + ".osgt", osg::Vec3(14.919, -206.348, 2.106), 70.806));
	//forge
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/forge/forge" + dir2 + ".osgt", osg::Vec3(-20.723, -239.787, 4.815), 180));
	//mill1
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/mill/mill" + dir2 + ".osgt", osg::Vec3(47.042, -250.118, -0.042), -166.637));
	//house2
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house2/house2" + dir2 + ".osgt", osg::Vec3(41.085, -215.204, 0.661), 99.564));
	//greekhouse
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/greekhouse/greekhouse" + dir2 + ".osgt", osg::Vec3(73.219, -194.181, 4.909), -159.056));
	//house4
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house4/house4" + dir2 + ".osgt", osg::Vec3(33.254, -176.294, 0.67 ), 168.261));
	//house1
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house1/house1" + dir2 + ".osgt", osg::Vec3(31.062, -131.258, -0.071 ), 78.774));
	//house2
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house2/house2" + dir2 + ".osgt", osg::Vec3(42.613, -98.27, 2.486 ), -60.665));
	//mill
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/mill/mill" + dir2 + ".osgt", osg::Vec3(72.678, -87.667, 14.425 ), -55.168));
	//hut2
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/hut/hut" + dir2 + ".osgt", osg::Vec3(113.302, -158.363, 2.958 ), -85.326));
	//house4
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house4/house4" + dir2 + ".osgt", osg::Vec3(135.164, -81.466, 7.433 ), 138.008));
	//well
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/well/well" + dir2 + ".osgt", osg::Vec3(150.419, -140.684, 1.47 ), -28.315));
	//house6
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house6/house6" + dir2 + ".osgt", osg::Vec3(152.428, -172.994, 8.638 ), 126.392));
	//house5
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house5/house5" + dir2 + ".osgt", osg::Vec3(167.274, -96.371, 0), -52.957));
	//house1
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/house1/house1" + dir2 + ".osgt", osg::Vec3(180.524, -143.634, -0.035), -131.179));
	//big_castle
	_sceneNode->addChild(LoadAndSetObject("Models/full_scene/objects/big_castle/big_castle" + dir2 + ".osgt", osg::Vec3(212.912, -183.173, 1.086), -115));

	osg::Group* g = new osg::Group();
	//g->addChild(LoadAndSetObject("Models/full_scene/trees/tree4/tree4.osgt", osg::Vec3(4.259, -8.229, 7.725+5), 0, osg::Vec3(1, 1, 1)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree1/tree1" + dir2 + ".osgt", osg::Vec3(-6.854, -44.699, 7.603), 10, osg::Vec3(2, 2, 2)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree2/tree2" + dir2 + ".osgt", osg::Vec3(31.119, -76.679, 10.56-4), 30, osg::Vec3(1, 1, 0.5)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree1/tree1" + dir2 + ".osgt", osg::Vec3(7.373, -128.302, 7.256), 100));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree2/tree2" + dir2 + ".osgt", osg::Vec3(-33.803, -175.583, 9.918),70, osg::Vec3(1, 1, 2)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree1/tree1" + dir2 + ".osgt", osg::Vec3(49.167, -162.506, 8.613-4), 10, osg::Vec3(1, 1, 0.5)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree2/tree2" + dir2 + ".osgt", osg::Vec3(96.991, -139.66, 11.642), 0, osg::Vec3(1, 1, 2)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree1/tree1" + dir2 + ".osgt", osg::Vec3(131.574, -169.169, 16.461),30));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree2/tree2" + dir2 + ".osgt", osg::Vec3(185.929, -109.527, 9.763-4), 40, osg::Vec3(1, 1, 0.5)));
	g->addChild(LoadAndSetObject("Models/full_scene/trees/tree1/tree1" + dir2 + ".osgt", osg::Vec3(176.887, -180.468, 13.726), 70, osg::Vec3(2, 2, 2)));


	g->getOrCreateStateSet()->setMode(GL_BLEND,osg::StateAttribute::ON);
	g->getOrCreateStateSet()->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

	osg::BlendFunc* fnc = new osg::BlendFunc;
    fnc->setFunction(osg::BlendFunc::SRC_ALPHA,osg::BlendFunc::ONE_MINUS_SRC_ALPHA);
    g->getOrCreateStateSet()->setAttributeAndModes( fnc, osg::StateAttribute::ON );

	_sceneNode->addChild(g);
	
}


void MyFullScene::CreateScene(bool in_paged, bool in_moreTextures, bool in_mipmap, bool in_impostor)
{
		
	CreateLODScene(in_paged, in_moreTextures, in_mipmap);

	string left = "Cubemap_snow/sun/left.jpg";
	string right = "Cubemap_snow/sun/right.jpg";
	string front = "Cubemap_snow/sun/front.jpg";
	string back = "Cubemap_snow/sun/back.jpg";
	string top = "Cubemap_snow/sun/top.jpg";
	string bottom = "Cubemap_snow/sun/bottom.jpg";
	CreateSkyBox(left, right, back, front, top, bottom);

	SetStartPosition(osg::Vec3(0,300,50));
}

osg::Vec4 MyFullScene::GetClearColor()
{
	return osg::Vec4(0, 0.8, 0, 1);
}
