//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYSCENE_H
#define MYSCENE_H 1

#include <osg/Geode>
#include <osg/TexGen>
#include <osg/Texture2D>

#include <osgDB/ReadFile>

#include <osg/ShapeDrawable>
#include <osg/MatrixTransform>
#include <osgViewer/Viewer>
#include <osgUtil/Optimizer>
#include <osg/BlendFunc>
#include <osgSim/Impostor>

#include <osgGA/FirstPersonManipulator>

#include <osg/PositionAttitudeTransform>

#include "SkyBox.h"


using namespace std;


class MyScene 
{

public:

	MyScene();

	osg::Vec3 GetStartPosition();

	osg::Group* GetScene();

	virtual void CreateScene(bool in_paged, bool in_moreTextures, bool in_mipmap, bool in_impostor);

	virtual osg::Vec4 GetClearColor();
	


protected:
	osg::ref_ptr<osg::Group> _sceneNode;
	osg::ref_ptr<SkyBox> _skyBox;
	osg::ref_ptr<osg::Group> _root;

	osg::Vec3 _startPosition;

	osg::Vec4 _ld, _la, _lp;

	osg::Node* createLight();

	void CreateSkyBox( string in_posX, string in_negX, string in_posY, string in_negY, string in_posZ, string in_negZ );
	void SetStartPosition(osg::Vec3 in_pos);
	osg::PositionAttitudeTransform* LoadAndSetObject(std::string in_path, osg::Vec3 in_pos, float in_angel, osg::Vec3 in_scale);
	osg::PositionAttitudeTransform* LoadAndSetObject(std::string in_path, osg::Vec3 in_pos, float in_angel);
	osg::PositionAttitudeTransform* LoadAndSetObject(std::string in_path, osg::Vec3 in_pos);
	osg::PositionAttitudeTransform* SetObject(osg::Node* in_node, osg::Vec3 in_pos, float in_angel, osg::Vec3 in_scale);

	osgDB::ReaderWriter::Options *_options;

};

#endif
