//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyTerrainScene.h"


void MyTerrainScene::CreateLODScene(bool in_paged, bool in_moreTextures, bool in_mipmap) 
{
	string dir = "LOD";
	if (in_paged)
		dir = "Paged" + dir;
	if (in_moreTextures)
		dir += "_t";
	if (in_mipmap)
		dir += "_m";

	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T11.osgt", osg::Vec3(-18.717, -224.813, 1.972)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T12.osgt", osg::Vec3(73.848, -224.812, 5.333)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T13.osgt", osg::Vec3(159.607, -223.781, 8.303)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T14.osgt", osg::Vec3(235.837, -223.781, 6.884)));

	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T21.osgt", osg::Vec3(-18.717, -122.031, 2.125)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T22.osgt", osg::Vec3(73.848, -122.031, 7.719)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T23.osgt", osg::Vec3(159.267, -121.344, 9.566)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T24.osgt", osg::Vec3(235.497, -121.344, 12.13)));

	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T31.osgt", osg::Vec3(-18.377, -25.094, 9.675)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T32.osgt", osg::Vec3(74.188, -25.094, 22.758)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T33.osgt", osg::Vec3(159.607, -25.438, 19.405)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T34.osgt", osg::Vec3(235.837, -25.438, 12.279)));

	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T41.osgt", osg::Vec3(-18.036, 61.531, 11.251)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T42.osgt", osg::Vec3(74.529, 61.531, 17.722)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T43.osgt", osg::Vec3(159.947, 61.531, 17.206)));
	_sceneNode->addChild(LoadAndSetObject("Models/terrain/" + dir + "/T44.osgt", osg::Vec3(236.177, 61.531, 9.357)));

}


void MyTerrainScene::CreateScene(bool in_paged, bool in_moreTextures, bool in_mipmap, bool in_impostor)
{
		
		
	CreateLODScene(in_paged, in_moreTextures, in_mipmap);

	string t1 = "Cubemap_snow/space/sky.jpg";
	string t2 = "Cubemap_snow/space/sky2.jpg";
	CreateSkyBox(t1, t1, t1, t2, t1, t1);

	SetStartPosition(osg::Vec3(0,300,50));
}