//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYBOUNDINGBOX_H
#define MYBOUNDINGBOX_H

#include <osg/NodeVisitor>
#include <osg/BoundingBox>
#include <osg/BoundingSphere>
#include <osg/MatrixTransform>
#include <osg/Billboard>
#include <osg/Drawable>
#include <osg/group>
#include <osg/ref_ptr>
#include <osg/NodeVisitor>

// trieda sluzi aby bounding box bol co najtesnejsie na modely
class  MyBoundingBox : public osg::NodeVisitor {

public:

	osg::Vec3 Min, Max;


	MyBoundingBox() : NodeVisitor(NodeVisitor::TRAVERSE_ALL_CHILDREN) 
	{
		Min = osg::Vec3(0,0,0);
		Max = osg::Vec3(0,0,0);
	}

    virtual void apply( osg::Geode &in_geode ) {
		osg::Vec3 tmp_vec;
		osg::Vec3Array* arr;		
        for (unsigned int i = 0; i < in_geode.getNumDrawables(); i++ ) {
			arr = (osg::Vec3Array*)in_geode.getDrawable(i)->asGeometry()->getVertexArray();
			for (unsigned int t=0; t<arr->getNumElements(); t++) {
				tmp_vec = arr->at(t);
				if (tmp_vec.x() > Max.x())
					Max = osg::Vec3(tmp_vec.x(), Max.y(), Max.z());
				if (tmp_vec.y() > Max.y())
					Max = osg::Vec3(Max.x(), tmp_vec.y(), Max.z());
				if (tmp_vec.z() > Max.z())
					Max = osg::Vec3(Max.x(), Max.y(), tmp_vec.z());

				if (tmp_vec.x() < Min.x())
					Min = osg::Vec3(tmp_vec.x(), Min.y(), Min.z());
				if (tmp_vec.y() < Min.y())
					Min = osg::Vec3(Min.x(), tmp_vec.y(), Min.z());
				if (tmp_vec.z() < Min.z())
					Min = osg::Vec3(Min.x(), Min.y(), tmp_vec.z());
			}
        } 
		traverse(in_geode);
	}   



};


#endif