//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYCAPACITYCOUNTER_H
#define MYCAPACITYCOUNTER_H

#include <osgViewer/Viewer>
#include <osgGA/CameraManipulator>
#include <osgGA/TrackballManipulator>
#include <osgUtil/Optimizer>
#include <osgDB/readfile>
#include <osgDB/ImagePager>
#include <osgDB/WriteFile>
#include <osg/Drawable>
#include <osg/group>
#include <osg/ProxyNode>
#include <osg/ref_ptr>
#include <osg/NodeVisitor>
#include <osg/LineSegment>
#include <osgUtil/IntersectVisitor>
#include <array>

#include "MyBoundingBox.h"


#define GRID_SIZE 50

using namespace osg;
using namespace std;

class MyCapacityCounter
{
public:
	MyCapacityCounter();
	~MyCapacityCounter();

	double GetCapacity(osg::Node* in_node);
	unsigned long GetMaxCapacity();




private:
	//unsigned char data[GRID_SIZE][GRID_SIZE][GRID_SIZE];
	unsigned char ***data;
	//vector<vector<vector<unsigned char>>> data;

	//osgUtil::IntersectVisitor *iv;
	osg::LineSegment* _lines[32];
	int _poc_lines;

	std::vector<unsigned char> *stackX;
	std::vector<unsigned char> *stackY;
	std::vector<unsigned char> *stackZ;
	osg::Vec3 vec_max, vec_min;
	osg::Vec3 one_step;
	osg::Node* _object;

	void ComputePoint(Vec3i in_vec);
	void SetCompletedByRay(Vec3 in_a, Vec3 in_b);
	void FlushRays();
	void ThrowRay(Vec3i in_xyz, Vec3i in_vec);

	osg::Vec3 GetPositionFromXYZ(Vec3i in_xyz);
	osg::Vec3i GetXYZFromPosition(Vec3 in_pos);

	bool IsOutOfRange(Vec3i in_xyz);
	Vec3i RepairRange(Vec3i in_xyz);
	bool IsPointValue(Vec3i in_xyz, unsigned char in_data);
	void SetPointValue(Vec3i in_xyz, unsigned char in_data);

	bool IsCompleteAll(Vec3i in_xyz);

	void ClearStack();
	int GetStackSize();
	void AddPointToStack(Vec3i in_xyz);
	Vec3i GetPointFromStack();
	
};


#endif