//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyGUIImageCompare.h"


MyGUIImageCompare::MyGUIImageCompare() : QMainWindow()
{
	setGeometry( 100, 100, 200, 200 );	
	QTimer timer;   
    timer.singleShot(100, this, SLOT(hide()));
	InitGUI();
}

// z hlavneho okna sa nastavia data k zobrazeniu
void MyGUIImageCompare::SetData(MyImageCompare *in_data)
{
	_data = in_data;
	QImage* img = _data->GetDifImage();	
	QLabel *l = new QLabel();
	l->setPixmap(QPixmap::fromImage(*img));
	setCentralWidget(l);
	_lBadPixels->setText(QString::number(_data->GetBadPixels()));
	_lPixelsCount->setText(QString::number(_data->GetPixelsCount()));
	_lBPixelsError->setText(QString::number(_data->GetBadPixelsError()) + " %");
	_lCompleteError->setText(QString::number(_data->GetCompleteError()) + " %");
}

//inicializuje gui okno pre porovnanie
void MyGUIImageCompare::InitGUI()
{

	_toolBar = new QToolBar( this );
	_toolBar->setObjectName( "Toolbar" );
	_toolBar->setMovable( false );
	_toolBar->setOrientation( Qt::Horizontal );
	addToolBar( Qt::BottomToolBarArea, _toolBar );


	_lPixelsCount = new QLabel("");
	_toolBar->addWidget(new QLabel("Pixels: "));
	_toolBar->addWidget(_lPixelsCount);
	
	_toolBar->addSeparator();
	_toolBar->addSeparator();

	_lBadPixels = new QLabel("");
	_toolBar->addWidget(new QLabel("Bads: "));
	_toolBar->addWidget(_lBadPixels);

	_toolBar->addSeparator();
	_toolBar->addSeparator();

	_lBPixelsError = new QLabel("");
	_toolBar->addWidget(new QLabel("Bads Error: "));
	_toolBar->addWidget(_lBPixelsError);

	_toolBar->addSeparator();
	_toolBar->addSeparator();

	_lCompleteError = new QLabel("");
	_toolBar->addWidget(new QLabel("Complete Error: "));
	_toolBar->addWidget(_lCompleteError);


}