//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYGUIIMAGECOMPARE_H
#define MYGUIIMAGECOMPARE_H

#include <QTimer>
#include <QApplication>
#include <QGridLayout>
#include <QFrame>
#include <QToolBar>
#include <QDoubleSpinBox>
#include <QLabel>
#include <QComboBox>
#include <QFileDialog>
#include <QMessageBox>
#include <QListWidget>
#include <QPushButton>
#include <QHBoxLayout>

#include <osgViewer/CompositeViewer>
#include <osgViewer/ViewerEventHandlers>
#include <osgUtil/simplifier>
#include <osgUtil/cullvisitor>
#include <osgGA/TrackballManipulator>
#include <osgDB/ReadFile>
#include <osgQt/GraphicsWindowQt>
#include <osg/polygonmode>

#include <iostream>
#include <QMainWindow>
#include <QMenuBar>


#include "MyLODProject.h"
#include "MyPixelSizeCallback.h"
#include "MySnapImage.h"
#include "MyImageCompare.h"



class MyGUIImageCompare : public QMainWindow
{

	Q_OBJECT

public:

    MyGUIImageCompare();

	void InitGUI();

	void SetData(MyImageCompare *in_data);

private:

	MyImageCompare *_data;

	QToolBar *_toolBar;

	QLabel *_lPixelsCount;
	QLabel *_lBadPixels;
	QLabel *_lBPixelsError;
	QLabel *_lCompleteError;

};

#endif
