//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYIMAGECOMPARE_H
#define MYIMAGECOMPARE_H

#include <osgViewer/Viewer>
#include <osgGA/CameraManipulator>
#include <osgGA/TrackballManipulator>
#include <osgUtil/Optimizer>
#include <osgDB/readfile>
#include <osgDB/ImagePager>
#include <osgDB/WriteFile>
#include <osg/Drawable>
#include <osg/group>
#include <osg/ProxyNode>
#include <osg/ref_ptr>
#include <osg/NodeVisitor>

#include <QImage>


class MyImageCompare
{
public:

	void CompareImages(osg::Image* in_img1, osg::Image* in_img2, osg::Vec4 in_background);
	void CompareImages(QImage* in_img1, QImage* in_img2, osg::Vec4 in_background);

	void CompareSobels(osg::Image* in_img1, osg::Image* in_img2, osg::Vec4 in_background);
	void CompareSobels(QImage* in_img1, QImage* in_img2, osg::Vec4 in_background);

	QImage* ComputeSobel(QImage* in_img);
	float ComputeIntensity(osg::Vec4 in_col);
	float ComputeIntensity(QRgb in_col);

	QImage* OSGImageToQImage(osg::Image* in_img);

	QImage* GetDifImage();

	long GetBadPixels();
	long GetPixelsCount();
	double GetBadPixelsError();
	double GetCompleteError();

private:

	double _badPixelsError;
	double _completeError;
	long   _badPixels;
	long   _pixelsCount;

	QImage* _difImage;

};

#endif