//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYLODHISTORY_H
#define MYLODHISTORY_H


#include <osgViewer/Viewer>
#include <osgUtil/Simplifier>
#include <osgUtil/Optimizer>
#include <osgDB/readfile>
#include <osgDB/ImagePager>
#include <osgDB/WriteFile>
#include <osg/Drawable>
#include <osg/group>
#include <osg/ProxyNode>
#include <osg/ref_ptr>
#include <osg/NodeVisitor>

#include <QVector>

#include <vector>
#include <map>
#include <list>

#include <iostream>
#include <fstream>
#include <string>

#include <ctime>


using namespace std;
using namespace osg;


#define COPY_OPTS (osg::CopyOp::DEEP_COPY_ARRAYS | osg::CopyOp::DEEP_COPY_CALLBACKS | osg::CopyOp::DEEP_COPY_DRAWABLES | osg::CopyOp::DEEP_COPY_NODES | osg::CopyOp::DEEP_COPY_PRIMITIVES | osg::CopyOp::DEEP_COPY_SHAPES)


struct MyLODHistoryLine {
	string desc;
	time_t time;
	ref_ptr<Node> savedNode;
};


class MyLODHistory {
	
public:
	MyLODHistory();
	~MyLODHistory();

	void CreateHistoryLine(string in_desc, Node* in_saveNode);

	bool IsUndoPossible();
	bool IsRedoPossible();

	Node* Undo();
	Node* Redo();


	string GetListOfHistory();

	
private:

	QVector<MyLODHistoryLine*> *_history;
	int _historyIndex;
	
};




#endif