//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyPixelSizeCallback.h"


MyPixelSizeCallback::MyPixelSizeCallback() : PixelSize(0) 
{
}


 void MyPixelSizeCallback::operator()(osg::Node* node, osg::NodeVisitor* nv)
{
    osg::CullStack* cullStack = dynamic_cast<osg::CullStack*>(nv);
	if (cullStack && cullStack->getLODScale())
	{
		osg::BoundingSphere bs = node->computeBound();
		PixelSize = cullStack->pixelSize(bs) / cullStack->getLODScale();
		PixelLength = ((bs.radius()*2.0) / PixelSize);
	}
    traverse(node, nv); 
}