//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYTEXTURESTORE_H
#define MYTEXTURESTORE_H

#include <osg/NodeVisitor>
#include <osg/Geode>
#include <osg/Geometry>
#include <osgDB/WriteFile>

#include <map>
#include <vector>
#include <string>
#include <sstream>

#include <QDir>
#include <QString>

#include "MyTextureStoreSlot.h"

class MyTextureStore : public osg::NodeVisitor
{
    public:
		
		MyTextureStore();

		virtual void apply(osg::Node& node);
		virtual void apply(osg::Geode& geode);

		void Clear();

		void DoStateSet(osg::StateSet* in_state);

		std::vector<std::string> GetTexturesNames();

		void ResizeTexture(std::string in_name, int in_rate);

		void SetTextureOriginal(std::string in_name, osg::Image* in_origImage);

		osg::Image* GetImage(std::string in_name);		


		
		void SetImagePath(std::string in_path);

		void SaveImages(QString, bool in_folderPerFile = false, bool in_completeNames = true);

		void ComputeImagesNames(bool in_folderPerFile = false, bool in_completeNames = true);
		void RestoreImagesNames();


	private:		

		std::string GetFileName(std::string in_path);

		std::string GetFilePath(std::string in_file);


		std::map<std::string, std::vector<MyTextureStoreSlot*>*> *textSlots;


};

#endif