//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyTextureStoreSlot.h"

//prepocita podla velkosti textury stringovu konstantu pre velkosti
void MyTextureStoreSlot::UpdateSizes()
{
	std::stringstream  tmp_sizes;
	osg::Image* img = Texture->getImage(0);
	tmp_sizes << img->s() << "_" << img->t() << "_";
	Sizes = tmp_sizes.str();
}

//nastavi znova image filenames na originalne
void MyTextureStoreSlot::RestoreImageName()
{
	Texture->getImage(0)->setFileName(OrigFileName);
}

//prepoc=ita nove nazvy images podla nastavenia a podla cieloveho ukladania
void MyTextureStoreSlot::ComputeImageName(bool in_folderPerFile, bool in_completeNames)
{
	std::string file_name, file_dir;
	UpdateSizes();

	if (in_completeNames)
		file_name = GetCompleteFileName();
	else 
		file_name = OrigFileName;

	if (in_folderPerFile)
		file_dir = Sizes + "/";
	else
		file_dir = "";

	Texture->getImage(0)->setFileName(Path + file_dir + file_name);
}

std::string MyTextureStoreSlot::GetCompleteFileName()
{
	UpdateSizes();
	return Sizes + OrigFileName;
}