//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#include "MyVertCount.h"


 MyVertCount::MyVertCount() : 
	osg::NodeVisitor( osg::NodeVisitor::TRAVERSE_ALL_CHILDREN ),
	_polyCount(0)
 {
	
 }


long MyVertCount::GetPolyCount()
{
 return _polyCount;
}

// vypocet kolko ma trojuholnikov objekt
void MyVertCount::apply( osg::Geode& in_geode )
{
	int mode;
	long inds;

	for (unsigned int t=0; t<in_geode.getNumDrawables(); t++) {
		for (unsigned int i=0; i<in_geode.getDrawable(t)->asGeometry()->getNumPrimitiveSets(); i++) {
			mode = in_geode.getDrawable(t)->asGeometry()->getPrimitiveSet(i)->getMode();
			inds = in_geode.getDrawable(t)->asGeometry()->getPrimitiveSet(i)->getNumIndices();
			if (mode == osg::PrimitiveSet::TRIANGLES)
				_polyCount += inds / 3;	
			else if (mode == osg::PrimitiveSet::TRIANGLE_STRIP || mode == osg::PrimitiveSet::TRIANGLE_FAN)
				_polyCount += inds - 2;
		}
	}

	traverse( in_geode );
}