//======================================
//=== Copyright (c) 2014 Dušan Hupka ===
//=== BSD License                    ===
//=== xhupka00@stud.fit.vutbr.cz     ===
//======================================



#ifndef MYVERTREPAIR_H
#define MYVERTREPAIR_H

#include <osgViewer/Viewer>
#include <osgGA/CameraManipulator>
#include <osgGA/TrackballManipulator>
#include <osgUtil/Optimizer>
#include <osgDB/readfile>
#include <osgDB/ImagePager>
#include <osgDB/WriteFile>
#include <osg/Drawable>
#include <osg/group>
#include <osg/ProxyNode>
#include <osg/ref_ptr>
#include <osg/NodeVisitor>


class MyVertexRepair : public osg::NodeVisitor
{
public:
	MyVertexRepair() : osg::NodeVisitor( osg::NodeVisitor::TRAVERSE_ALL_CHILDREN ) {}

	osg::PrimitiveSet* ReplaceIndices(osg::PrimitiveSet* in_ps, std::map<unsigned int, long>* in_ver);

	bool IsNear(osg::Vec3 in_a, osg::Vec3 in_b, float in_near);

	void DoDrawable(osg::Drawable* in_draw);

	virtual void apply( osg::Geode& in_geode );

protected:
    unsigned long _polyCount;
    osg::ref_ptr<osg::Node> _node;
};


#endif